//  BMPx - The Dumb Music Player
//  Copyright (C) 2005 BMPx development team.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  --
//
//  The BMPx project hereby grants permission for non-GPL compatible GStreamer
//  plugins to be used and distributed together with GStreamer and BMPx. This
//  permission is above and beyond the permissions granted by the GPL license
//  BMPx is covered by.

#ifndef BMP_FILELIST_HPP
#define BMP_FILELIST_HPP

#include <gtkmm.h>
#include <libglademm.h>

#include "file_utils.hpp"

namespace Bmp
{
  class DialogFilelist
      : public Gtk::Dialog
  {
  public:

      DialogFilelist (BaseObjectType                        *cobject,
                      const Glib::RefPtr<Gnome::Glade::Xml> &xml);

      static DialogFilelist*
      create ();

      ~DialogFilelist ();

      int
      run (const Bmp::Util::FileList& list);

  private:

	  class CRFiles
	    : public Gtk::TreeModel::ColumnRecord
	  {
	    public:
	      Gtk::TreeModelColumn<Glib::ustring> name;

	      CRFiles ()
	      {
          add (name);
	      }
	  };
	  CRFiles cr_files; 

    Glib::RefPtr<Gnome::Glade::Xml>	 ref_xml;
    Gtk::TextView                   *view_files;

  };

} // namespace Bmp

#endif // BMP_FILELIST_HPP

