//  BMPx - The Dumb Music Player
//  Copyright (C) 2005 BMPx development team.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  --
//
//  The BMPx project hereby grants permission for non-GPL compatible GStreamer
//  plugins to be used and distributed together with GStreamer and BMPx. This
//  permission is above and beyond the permissions granted by the GPL license
//  BMPx is covered by.

#ifndef BMP_FILEBROWSER_HPP 
#define BMP_FILEBROWSER_HPP

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <glibmm.h>
#include <glibmm/markup.h>
#include <gtkmm.h>
#include <libglademm.h>

namespace Bmp
{
  class FileBrowser
    : public Gtk::Window
  {
    public:

	enum Mode
	{
	  PLAY,
	  ADD,
	};

	FileBrowser (BaseObjectType                       *cobject,
		     const Glib::RefPtr<Gnome::Glade::Xml> &xml);

	static FileBrowser*
	create ();
	void
	run (Mode mode);

    protected:

	// VMethods inherited from Gtk::Widget
	virtual bool
	on_key_press_event (GdkEventKey *event);

	virtual bool
	on_delete_event (GdkEventAny *event);

    private:

      // Methods
      bool
      audio_files_filter (const Gtk::FileFilter::Info& info);
      void
      execute ();
      void
      hide ();
      void
      toggle_toggled ();
	
      // GladeXML Data
      Glib::RefPtr<Gnome::Glade::Xml> ref_xml;
      Gtk::FileChooserWidget *chooser;
      Gtk::Button	*action,
			*close;
      Gtk::Button	*select_all,
			*deselect_all;
      Gtk::CheckButton	*toggle;

      // Data
      Mode mode;
      bool block_toggle;
  };
}
#endif
