#include <glibmm.h>
#include <glib.h>
#include "guid.hpp"

bool
row_guid_equal_func (RowGUID *guid_a, RowGUID *guid_b)
{
    g_return_val_if_fail (guid_a != NULL, FALSE);
    g_return_val_if_fail (guid_b != NULL, FALSE);

    return (guid_a->counter == guid_b->counter);
}

unsigned int
row_guid_hash_func (RowGUID *guid)
{
    return guid->counter;
}

RowGUID*
row_guid_copy (RowGUID *guid)
{
  RowGUID *copy = g_new0 (RowGUID,1);
  copy->counter = guid->counter;
  return copy;
}

void
row_guid_free (RowGUID *guid)
{
  g_free (guid);
}

GType
row_guid_get_type (void)
{
    static GType our_type = 0;

    if (our_type == 0)
        our_type = g_boxed_type_register_static ("BmpRowGUID",
                                                 (GBoxedCopyFunc)
                                                 row_guid_copy,
                                                 (GBoxedFreeFunc)
                                                 row_guid_free);
    return our_type;
}

namespace { unsigned int guid_counter = 0; }

RowGUID*
row_guid_new ()
{
    RowGUID *guid;

    guid = g_new0 (RowGUID,1);
    guid->counter = guid_counter++;
    return guid;
}
