#ifndef BMP_HISTORY_HPP
#define BMP_HISTORY_HPP

#include <glibmm.h>
#include <gtkmm.h>
#include "interfaces.h"
#include "guid.hpp"

struct BmpPlaybackHistory
{
    GQueue        *history;
    int            mark;
    bool           dirty;
    GHashTable	  *mapping;
};

BmpPlaybackHistory*
bmp_playback_history_new                ();

void
bmp_playback_history_free               (BmpPlaybackHistory         *history);

void
bmp_playback_history_set                (BmpPlaybackHistory         *history,
                                         int                         position);

int
bmp_playback_history_prev               (BmpPlaybackHistory         *history,
                                         BmpPluginFlowInterface     *plugin);

int
bmp_playback_history_next               (BmpPlaybackHistory         *history,
                                         BmpPluginFlowInterface     *plugin);

int
bmp_playback_history_rewind             (BmpPlaybackHistory         *history);

void
bmp_playback_history_remove_guid	      (BmpPlaybackHistory	        *history,
                                         RowGUID		                *guid);

#endif
