//  BMPx - The Dumb Music Player
//  Copyright (C) 2005 BMPx development team.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  --
//
//  The BMPx project hereby grants permission for non-GPL compatible GStreamer
//  plugins to be used and distributed together with GStreamer and BMPx. This
//  permission is above and beyond the permissions granted by the GPL license
//  BMPx is covered by.

#ifndef BMP_LASTFM_RECOMMEND_HPP 
#define BMP_LASTFM_RECOMMEND_HPP 

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <glibmm.h>
#include <glibmm/markup.h>
#include <gtkmm.h>
#include <libglademm.h>

namespace Bmp
{
  namespace LastFM
  {
    class RecommendDialog
      : public Gtk::Dialog
    {
      public:

        RecommendDialog (BaseObjectType                       *cobject,
                         const Glib::RefPtr<Gnome::Glade::Xml> &xml);

        ~RecommendDialog ();

        static RecommendDialog*
        create ();

        void
        run (Glib::ustring const& uri);

      private:

        void
        lastfm_enable_changed  (MCS_CB_DEFAULT_SIGNATURE);

        void
        update_view ();

        class FriendsCR
            : public Gtk::TreeModel::ColumnRecord
        {
          public:

            Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> > avatar;
            Gtk::TreeModelColumn<Glib::ustring>              name;
            Gtk::TreeModelColumn<Glib::ustring>              username;

            FriendsCR()
            {
              add (avatar);
              add (name);
              add (username);
            }
        };
        FriendsCR  friends_cr;

        // GladeXML+Widgets
        Glib::RefPtr<Gnome::Glade::Xml>    m_ref_xml;

        Glib::RefPtr<Gtk::ListStore>       liststore;
        Gtk::TreeView                     *treeview;
        Gtk::Notebook                     *notebook;
        Gtk::Image                        *image;
        Gtk::Image                        *image_lastfm;

        Gtk::Entry                        *e_artist, *e_album, *e_title;
        Gtk::Label                        *l_artist, *l_album, *l_title;
        Gtk::ComboBox                     *cbox_recommend;
        Gtk::TextView                     *view_notes;

        void
        recommend_changed ();
        void
        recommend ();

    };
  }
}
#endif
