//  BMPx - The Dumb Music Player
//  Copyright (C) 2005 BMPx development team.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  --
//
//  The BMPx project hereby grants permission for non-GPL compatible GStreamer
//  plugins to be used and distributed together with GStreamer and BMPx. This
//  permission is above and beyond the permissions granted by the GPL license
//  BMPx is covered by.

#ifndef BMP_NOTIFY_HPP
#define BMP_NOTIFY_HPP

#include <gtkmm.h>

#include <libnotify/notify.h>
#include <libnotify/notification.h>

namespace Bmp
{
    enum NotifyException
    {
      UNABLE_TO_DBUS_CONNECT,
      UNABLE_TO_INTROSPECT_INTERFACE,
    };

    class Notify
    {
      public:

        Notify (GtkWidget *attach);
        ~Notify ();

        void
        set_notification (Glib::ustring const& summary,
                          Glib::ustring const& message,
                          unsigned int	     timeout);

        void
        set_notification (Glib::ustring const& summary,
                          Glib::ustring const& message,
                          unsigned int	       timeout,
                          Glib::ustring&       uri);

        void
        attach_to_widget (GtkWidget *widget);

        static void
        notification_closed (NotifyNotification *n, Bmp::Notify *notify);

      private:

        bool 
        set_notification_actual_default (Glib::ustring const& summary,
                                         Glib::ustring const& message,
                                         unsigned int         timeout);

        bool 
        set_notification_actual         (Glib::ustring const& summary,
                                         Glib::ustring const& message,
                                         unsigned int         timeout,
                                         Glib::ustring&       uri);
	
        Glib::RefPtr<Gdk::Pixbuf>  default_icon;
        NotifyNotification        *n;
        GtkWidget                 *attach;
        bool                       visible;
    };
} // ns::Bmp

#endif 

