#ifndef BMP_SHELL_HPP
#define BMP_SHELL_HPP

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtkmm.h>
#include <mcs/mcs.h>
#include <mcs/gtk-bind.h>

#include "winamp2_skin.hpp"
#include "winamp2_main.hpp"
#include "winamp2_playlist.hpp"

#ifdef HAVE_GAIM
#include "gaim_dbus.hpp"
#endif

#include "stock.hpp"

namespace Bmp
{
  extern Glib::RefPtr<Gtk::UIManager>    ui_manager;
  extern Glib::RefPtr<Gtk::ActionGroup>  actions;
  extern Glib::RefPtr<Gtk::ActionGroup>  actions_toggle;
  extern BmpWinamp2Skin                  *winamp2_skin;

  extern BmpWindowMain                   *w_main;
  extern BmpWindowPlaylist               *w_playlist;
  extern Mcs::Bind                       *mcs_bind;

#ifdef HAVE_GAIM
  extern Bmp::Gaim::DBUS                 *gaim_dbus;
#endif

  extern bool skin_changing;

  void
  shell_init ();

  void
  shell_stop ();

  bool
  shell_running ();

  void
  raise_windows ();
}

#endif
