#ifndef UI_UTIL_HPP
#define UI_UTIL_HPP

#include <config.h>
#include <gtk/gtk.h>
#include <gdkmm.h>
#include <gtkmm.h>

GtkWidget *
ui_manager_get_popup (GtkUIManager * self,
		      const gchar * path);

void
bmp_menu_popup (GtkMenu * menu,
		gint x,
		gint y,
		guint button,
		guint time);

#ifdef ENABLE_NLS
gchar *
bmp_menu_translate (const gchar *message,
                    gpointer     data);
#else
#define bmp_menu_translate NULL
#endif

void
bmp_window_set_busy (GtkWidget *widget);

void
bmp_window_set_idle (GtkWidget *widget);

void
bmp_window_set_icon_list (GtkWidget *window, const gchar *icon_name);

namespace Bmp
{
  namespace Util
  {
    void
    window_set_busy (Gtk::Window &window);

    void
    window_set_idle (Gtk::Window &window);

    // NOTE: gtkmm has no binding for gdk_screen_get_rgba_visual()
    Glib::RefPtr<Gdk::Visual>
    screen_get_rgba_visual (const Glib::RefPtr<Gdk::Screen> &screen);

    // NOTE: gtkmm has no binding for gdk_screen_get_rgba_colormap()
    Glib::RefPtr<Gdk::Colormap>
    screen_get_rgba_colormap (const Glib::RefPtr<Gdk::Screen> &screen);

    double
    screen_get_resolution (const Glib::RefPtr<Gdk::Screen> &screen);

    double
    screen_get_x_resolution (const Glib::RefPtr<Gdk::Screen> &screen);

    double
    screen_get_y_resolution (const Glib::RefPtr<Gdk::Screen> &screen);

  } // namespace Util

} // namespace Bmp

#endif
