//  BMPx - The Dumb Music Player
//  Copyright (C) 2005 BMPx development team.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  --
//
//  The BMPx project hereby grants permission for non-GPL compatible GStreamer
//  plugins to be used and distributed together with GStreamer and BMPx. This
//  permission is above and beyond the permissions granted by the GPL license
//  BMPx is covered by.

#ifndef BMP_WINAMP2_SKIN_HPP
#define BMP_WINAMP2_SKIN_HPP

#include <gtk/gtk.h>
#include <glib-object.h>

#define BMP_TYPE_WINAMP2_SKIN             (bmp_winamp2_skin_get_type ())
#define BMP_WINAMP2_SKIN(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), BMP_TYPE_WINAMP2_SKIN, BmpWinamp2Skin))
#define BMP_WINAMP2_SKIN_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass),  BMP_TYPE_WINAMP2_SKIN, BmpWinamp2SkinClass))
#define BMP_IS_WINAMP2_SKIN(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BMP_TYPE_WINAMP2_SKIN))
#define BMP_IS_WINAMP2_SKIN_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass),  BMP_TYPE_WINAMP2_SKIN))
#define BMP_WINAMP2_SKIN_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj),  BMP_TYPE_WINAMP2_SKIN, BmpWinamp2SkinClass))

struct BmpWinamp2SkinClass
{
    GObjectClass parent;
};

struct BmpWinamp2Skin
{
    GObject parent;
};

#define SET_CURSOR_FOR_WIDGET(cursor_enum,widget) \
  { \
    GdkCursor *cursor; \
      if (!GTK_WIDGET_REALIZED(widget)) gtk_widget_realize(GTK_WIDGET(widget)); \
      cursor = bmp_cursors_get_cursor (Wa2CursorId(cursor_enum)); \
      gdk_window_set_cursor (GTK_WIDGET(widget)->window, cursor); \
      if (cursor) \
        gdk_cursor_destroy (cursor); \
  }

#define BMP_DEFAULT_FONT                    "Sans 10"
#define BMP_DEFAULT_SKIN                    "default"

// Non-action defines
#define BMP_FILE_REGION                     "region.txt"
#define BMP_FILE_PLEDIT                     "pledit.txt"
#define BMP_MASK_REGION_SECTION_MAIN_WINDOW "normal"
#define BMP_MASK_REGION_SECTION_EQUALIZER   "equalizer"

enum Wa2SkinBitmap
{
    BITMAP_MAIN,
    BITMAP_SHUFREP,
    BITMAP_CBUTTONS,
    BITMAP_POSBAR,
    BITMAP_VOLUME,
    BITMAP_TITLEBAR,
    BITMAP_BALANCE,
    BITMAP_PLEDIT,
    BITMAP_MONOSTER,
    BITMAP_NUMBERS,
    BITMAP_PLAYPAUSE,

    N_BITMAPS
};

enum Wa2SkinColor
{
    COLOR_PL_BG_NORMAL,
    COLOR_PL_FG_NORMAL,
    COLOR_PL_BG_SELECTED,
    COLOR_PL_FG_CURRENT,

    N_COLORS
};

enum Wa2CursorId
{
    CURSOR_NORMAL,
    CURSOR_POSBAR,
    CURSOR_VOLBAR,
    CURSOR_PLAYLIST,
    CURSOR_PLAYLIST_SIZE,
    CURSOR_MAINMENU,

    N_CURSORS
};

enum BmpSkinType
{
    BMP_SKIN_ARCHIVE,
    BMP_SKIN_DIR
};

extern GdkPixbuf  *wa2_skin_bitmap[N_BITMAPS];
extern GdkBitmap  *mask_window_main;
extern int         _skin_n_numbers;

GType               bmp_winamp2_skin_get_type       (void);
BmpWinamp2Skin*     bmp_winamp2_skin_new            (void);
bool                bmp_winamp2_skin_load_skin      (BmpWinamp2Skin* skin, std::string const& path);

GdkCursor*
bmp_cursors_get_cursor  (Wa2CursorId cursor);

GdkColor*
bmp_colors_get_color    (Wa2SkinColor color);

#endif // BMP_WINAMP2_SKIN_HPP
