// (c) 2006 Martin Aumueller <aumuell@reserv.at>
// See COPYING file for licensing information

#include "aacfiletyperesolver.h"
#include <taglib/mpegfile.h>

#include <src/util.hpp>
#include <src/audio.hpp>

TagLib::File *AACFileTypeResolver::createFile (const char                        *filename,
                                               bool                               read_properties,
                                               TagLib::AudioProperties::ReadStyle properties_style) const
{
  std::string type;
  if (!Bmp::Audio::typefind (filename, type)) return 0;

  if (type == "application/x-id3")
    {
        return new TagLib::MPEG::File(filename, read_properties, properties_style);
    }
  return 0;
}
