// (C) 2006 M. Derezynski

#include "taglib_sidfiletyperesolver.h"
#include "sidfile.h"

#include <src/util.hpp>
#include <src/audio.hpp>

TagLib::File *SIDFileTypeResolver::createFile (const char                        *filename,
                                               bool                               read_properties,
                                               TagLib::AudioProperties::ReadStyle properties_style) const 
{
    std::string type;
    
    if (!Bmp::Audio::typefind (filename, type)) return 0;

    if (type == "audio/x-sid")
    {
        TagLib::SID::File *f = new TagLib::SID::File(filename, read_properties, properties_style);
        if(f->isValid())
            return f;
        else
        {
            delete f;
        }
    }

    return 0;
}
