// (c) 2005 Martin Aumueller <aumuell@reserv.at>
// See COPYING file for licensing information

#include "taglib_wmafiletyperesolver.h"
#include "wmafile.h"

#include <src/util.hpp>
#include <src/audio.hpp>

TagLib::File *WMAFileTypeResolver::createFile (const char                        *filename,
                                               bool                               read_properties,
                                               TagLib::AudioProperties::ReadStyle properties_style) const 
{
    std::string type;
    if (!Bmp::Audio::typefind (filename, type)) return 0;

    if (type == "video/x-ms-asf")
    {
        TagLib::WMA::File *f = new TagLib::WMA::File(filename, read_properties, properties_style);
        if(f->isValid())
            return f;
        else
        {
            delete f;
        }
    }
    return 0;
}
