#ifndef BMP_BUTTON_H
#define BMP_BUTTON_H
  
#include <gtk/gtk.h>

G_BEGIN_DECLS

#define BMP_BUTTON(obj)          G_TYPE_CHECK_INSTANCE_CAST (obj, bmp_button_get_type (), BmpButton)
#define BMP_BUTTON_CLASS(klass)  G_TYPE_INSTANCE_GET_CLASS (klass, bmp_button_get_type (), BmpButtonClass)
#define BMP_IS_BUTTON(obj)       G_TYPE_CHECK_INSTANCE_TYPE (obj, bmp_button_get_type ())
#define	BMP_TYPE_BUTTON		 (bmp_button_get_type())

typedef struct _BmpButton BmpButton;
typedef struct _BmpButtonClass BmpButtonClass;

struct _BmpButton
{
  GtkButton button; 

  gboolean constructed;
  gboolean in_button;

  GdkGC *gc;
 
  GdkPixbuf *pb_normal;
  GdkPixbuf *pb_pressed;
  
  unsigned int state;

  unsigned int width;
  unsigned int height;

  gpointer draw_data;

  gboolean passtrough;
};

struct _BmpButtonClass
{
  GtkButtonClass parent_class;
};

enum
{
  BMP_BUTTON_STATE_IDLE = 0,
  BMP_BUTTON_STATE_ACTIVE
};

GType
bmp_button_get_type          (void) G_GNUC_CONST;

BmpButton*
bmp_button_new               (gboolean passtrough);

void
bmp_button_set_from_table    (BmpButton	      *button,
                              const GdkPixbuf *source, 
                              unsigned int     width, 
                              unsigned int     height,
                              unsigned int     x_normal,
                              unsigned int     y_normal,
                              unsigned int     x_pressed,
                              unsigned int     y_pressed);
G_END_DECLS

#endif
