#ifndef __BMP_BUTTON_TOGGLE_H__
#define __BMP_BUTTON_TOGGLE_H__
  
#include <gdk/gdk.h>
#include <gtk/gtkwidget.h>
#include <gtk/gtk.h>

G_BEGIN_DECLS

#define BMP_BUTTON_TOGGLE(obj)          G_TYPE_CHECK_INSTANCE_CAST (obj, bmp_button_toggle_get_type (), BmpButtonToggle)
#define BMP_BUTTON_TOGGLE_CLASS(klass)  G_TYPE_INSTANCE_GET_CLASS  (klass, bmp_button_toggle_get_type (), BmpButtonToggleClass)
#define BMP_IS_BUTTON_TOGGLE(obj)       G_TYPE_CHECK_INSTANCE_TYPE (obj, bmp_button_toggle_get_type ())
#define	BMP_TYPE_BUTTON_TOGGLE		(bmp_button_toggle_get_type())

typedef struct _BmpButtonToggle BmpButtonToggle;
typedef struct _BmpButtonToggleClass BmpButtonToggleClass;

enum BmpButtonToggleStates
{
	BMP_BUTTON_TOGGLE_NORMAL,
	BMP_BUTTON_TOGGLE_PRESSED,
	BMP_BUTTON_TOGGLE_ACTIVE,

	BMP_BUTTON_TOGGLE_N_STATES
};

enum BmpButtonToggleActiveState 
{
    BMP_BUTTON_TOGGLE_STATE_IDLE    = 0,
    BMP_BUTTON_TOGGLE_STATE_ACTIVE
};

struct _BmpButtonToggle
{
  GtkToggleButton button; 

  gboolean constructed;
  gboolean in_button;

  GdkGC *gc;
  GdkPixbuf *state_pb[BMP_BUTTON_TOGGLE_N_STATES];
  unsigned int state;
  unsigned int width;
  unsigned int height;

};

struct _BmpButtonToggleClass
{
  GtkToggleButtonClass        parent_class;
};

GType
bmp_button_toggle_get_type          (void) G_GNUC_CONST;

BmpButtonToggle*
bmp_button_toggle_new               (void);

void
bmp_button_toggle_set_from_table (BmpButtonToggle *arg_button, const GdkPixbuf *src, 
                unsigned int            width, 
                unsigned int            height,
                unsigned int            x_normal,
                unsigned int            y_normal,
                unsigned int            x_pressed,
                unsigned int            y_pressed,
		unsigned int		 x_active,
		unsigned int		 y_active);

void	       bmp_button_toggle_toggled	   (BmpButtonToggle      *button);

G_END_DECLS

#endif
